package cn.org.bjca.trust.android.lib.im.common;

import android.os.Build;
import android.util.Log;

import java.lang.reflect.Field;
import java.util.List;

import cn.org.bjca.trust.android.lib.im.SZYXDbHelper;
import cn.org.bjca.trust.android.lib.im.db.device.DeviceEntity;

public class DeviceHelper {
    public static DeviceEntity getDevice() {
        List<DeviceEntity> entityList = SZYXDbHelper.get().deviceDao().getAll();
        if (entityList.size() == 0) {
            DeviceEntity device = new DeviceEntity();

            Field[] fields = Build.class.getDeclaredFields();
            for (Field field : fields) {
                try {
                    switch (field.getName()) {
                        case "MANUFACTURER":
                            device.setManufacturer(CommonHelper.anyToString(field.get(null)));
                            break;
                        case "BRAND":
                            device.setBrand(CommonHelper.anyToString(field.get(null)));
                            break;
                        case "MODEL":
                            device.setModel(CommonHelper.anyToString(field.get(null)));
                            break;
                        case "CPU_ABI":
                            device.setCpuAbi(CommonHelper.anyToString(field.get(null)));
                            break;
                        case "FINGERPRINT":
                            device.setFingerprint(CommonHelper.anyToString(field.get(null)));
                            device.setDeviceId(CommonHelper.anyToString(field.get(null)));
                            break;
                        case "SUPPORTED_32_BIT_ABIS":
                            device.setSupported32BitAbis(CommonHelper.anyToString(field.get(null)));
                            break;
                        case "SUPPORTED_64_BIT_ABIS":
                            device.setSupported64BitAbis(CommonHelper.anyToString(field.get(null)));
                            break;
                        case "SUPPORTED_ABIS":
                            device.setSupportedAbis(CommonHelper.anyToString(field.get(null)));
                            break;
                    }
                } catch (Exception ignored) {

                }
            }
            SZYXDbHelper.get().deviceDao().insertAll(device);
            return device;
        } else return entityList.get(0);
    }
}
