package cn.org.bjca.trust.android.lib.im.http;

import androidx.annotation.NonNull;

import java.io.IOException;

import cn.org.bjca.trust.android.lib.im.BuildConfig;
import cn.org.bjca.trust.android.lib.im.cfg.Constant;
import cn.org.bjca.trust.android.lib.im.enums.OsType;
import okhttp3.Interceptor;
import okhttp3.Response;

public class HeaderInterceptor implements Interceptor {
    @NonNull
    @Override
    public Response intercept(@NonNull Chain chain) throws IOException {

        return chain.proceed(chain.request().newBuilder()
                .header("AppID", Constant.getSdkAppID())
                .header("UserId", Constant.getUserId())
                .header("token", null == Constant.getToken() ? "" : Constant.getToken())
                .addHeader("Version", BuildConfig.versionName)
                .addHeader("OsType", String.valueOf(OsType.ANDROID.type()))
                .build());
    }
}
