package cn.org.bjca.trust.android.lib.im.http;


import java.util.concurrent.TimeUnit;

import cn.org.bjca.trust.android.lib.im.cfg.Constant;
import okhttp3.OkHttpClient;
import okhttp3.logging.HttpLoggingInterceptor;
import retrofit2.Retrofit;
import retrofit2.adapter.rxjava2.RxJava2CallAdapterFactory;
import retrofit2.converter.gson.GsonConverterFactory;

public class HttpManage {

    private static Retrofit retrofit;
    private static OkHttpClient okHttpClient;


    public static <T> T getApi(final Class<T> service) {

        if (null == okHttpClient) {
            OkHttpClient.Builder builder = new OkHttpClient.Builder();
            builder.hostnameVerifier((s, sslSession) -> true);
            HttpLoggingInterceptor loggingInterceptor = new HttpLoggingInterceptor();
            loggingInterceptor.setLevel(HttpLoggingInterceptor.Level.BODY);

            okHttpClient = builder
                    .connectTimeout(15, TimeUnit.SECONDS)
                    .addInterceptor(loggingInterceptor)
                    .addInterceptor(new HeaderInterceptor())
                    .build();
        }


        if (null == retrofit) {
            retrofit = new Retrofit.Builder()
                    .baseUrl(Constant.BaseUrl)
                    .client(okHttpClient)
                    .addConverterFactory(GsonConverterFactory.create())
                    .addCallAdapterFactory(RxJava2CallAdapterFactory.create())
                    .build();
        }


        return retrofit.create(service);
    }
}
