package cn.org.bjca.trust.android.lib.im.im.bean;

import java.util.UUID;

import cn.org.bjca.trust.android.lib.im.cfg.Constant;
import cn.org.bjca.trust.android.lib.im.enums.OsType;
import cn.org.bjca.trust.android.lib.im.enums.PacketType;

public abstract class PacketMessage {
    /**
     * 消息id
     */
    private String msgId = UUID.randomUUID().toString();
    private PacketType packetType;
    private long timestamp;
    private String appId;
    private String userName;
    private String token;
    private String osType;

    public PacketMessage(PacketType packetType) {
        this.packetType = packetType;
        this.timestamp = System.currentTimeMillis();
        this.appId = Constant.getSdkAppID();
        this.userName = Constant.getUserId();
        this.token = Constant.getToken();
        this.osType = String.valueOf(OsType.ANDROID.type());
    }

    public String getOsType() {
        return osType;
    }

    public void setOsType(String osType) {
        this.osType = osType;
    }

    public String getMsgId() {
        return msgId;
    }

    public void setMsgId(String msgId) {
        this.msgId = msgId;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public PacketType getPacketType() {
        return packetType;
    }

    public void setPacketType(PacketType packetType) {
        this.packetType = packetType;
    }

    public long getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(long timestamp) {
        this.timestamp = timestamp;
    }

    public String getAppId() {
        return appId;
    }

    public void setAppId(String appId) {
        this.appId = appId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    @Override
    public String toString() {
        return "PacketMessage{" +
                "msgId='" + msgId + '\'' +
                ", packetType=" + packetType +
                ", timestamp=" + timestamp +
                ", appId='" + appId + '\'' +
                ", userName='" + userName + '\'' +
                ", token='" + token + '\'' +
                ", osType='" + osType + '\'' +
                '}';
    }
}
