package cn.org.bjca.trust.android.imdemo.ui.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.widget.LinearLayout;

import androidx.databinding.DataBindingUtil;

import com.xuqm.base.adapter.BaseNormalAdapter;
import com.xuqm.base.adapter.ItemViewDelegate;
import com.xuqm.base.adapter.ViewHolder;
import com.xuqm.base.common.TimeHelper;

import cn.org.bjca.trust.android.imdemo.R;
import cn.org.bjca.trust.android.imdemo.databinding.ChatViewTextBinding;
import cn.org.bjca.trust.android.lib.im.SZYXImSdk;
import cn.org.bjca.trust.android.lib.im.im.msg.message.SZYXMessage;

public class ChatAdapter extends BaseNormalAdapter<SZYXMessage> {
    private Context mContext;

    public ChatAdapter(Context context) {
        this.mContext = context;
        addItemViewDelegate(new ItemViewDelegate<SZYXMessage>() {
            @Override
            public int getItemViewLayoutId() {
                return R.layout.chat_view_root_l;
            }

            @Override
            public boolean isForViewType(SZYXMessage item, int position) {
                return item.isArrive();
            }

            @Override
            public void convert(ViewHolder holder, SZYXMessage item, int position) {
                holder.setImage(R.id.avatar, SZYXImSdk.getInstance().getUser(item.getFromClientId()).getFaceUrl());
                holder.setText(R.id.name, SZYXImSdk.getInstance().getUser(item.getFromClientId()).getNickName());
                ChatAdapter.this.convert(holder, item, position);
            }
        });
        addItemViewDelegate(new ItemViewDelegate<SZYXMessage>() {
            @Override
            public int getItemViewLayoutId() {
                return R.layout.chat_view_root_r;
            }

            @Override
            public boolean isForViewType(SZYXMessage item, int position) {
                return !item.isArrive();
            }

            @Override
            public void convert(ViewHolder holder, SZYXMessage item, int position) {
                holder.setImage(R.id.avatar, SZYXImSdk.getInstance().getUser().getFaceUrl());
                ChatAdapter.this.convert(holder, item, position);
            }
        });
    }

    private void convert(ViewHolder holder, SZYXMessage item, int position) {
        holder.setText(R.id.time, TimeHelper.getStringFormMillis(item.getTimestamp(), "yyyy-MM-dd HH:mm"));
        LinearLayout root = holder.getView(R.id.content);
        switch (item.getMsgType()) {
            case Text:
                ChatViewTextBinding text = DataBindingUtil.inflate(LayoutInflater.from(this.mContext), R.layout.chat_view_text, root, true);
                text.text.setText(item.getTextMessage().getText());
                break;
            case Image:
                break;
            default:
                DataBindingUtil.inflate(LayoutInflater.from(this.mContext), R.layout.chat_view_unknown, root, true);
                break;
        }
    }
}
