package cn.org.bjca.trust.android.imdemo.vm;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;

import com.xuqm.base.common.LogHelper;
import com.xuqm.base.common.TimeHelper;
import com.xuqm.base.viewmodel.BaseViewModel;

import java.util.ArrayList;
import java.util.List;

import cn.org.bjca.trust.android.lib.im.SZYXImSdk;
import cn.org.bjca.trust.android.lib.im.im.msg.message.SZYXMessage;
import cn.org.bjca.trust.android.lib.im.kit.IMMsgCallback;

public class ChatVM extends BaseViewModel {
    private final MutableLiveData<List<SZYXMessage>> _message = new MutableLiveData<>();
    private final LiveData<List<SZYXMessage>> message = _message;

    public LiveData<List<SZYXMessage>> getMessage() {
        return message;
    }

    private final List<SZYXMessage> list = new ArrayList<>();
    private String userId;
    private long timestamp = TimeHelper.getTimeMillis();

    public void getMessageList(String userId) {
        this.userId = userId;

        SZYXImSdk.getMessageManager().getHistory(userId,timestamp, new IMMsgCallback() {
            @Override
            public void success(List<SZYXMessage> messages) {
                if (messages.size()>0){
                    list.addAll(0,messages);
                    timestamp = messages.get(0).getTimestamp();
                }
                _message.postValue(list);
            }

            @Override
            public void failed(int code, String error) {
                LogHelper.e("=====>", code + error);
                _message.postValue(null);
            }
        });
    }

    public void onRefresh() {
        this.getMessageList(this.userId);
    }
    public void add(SZYXMessage msg) {
        this.list.add(msg);
        _message.postValue(list);
    }
}
